package model;

public class ArrayQueue<E> implements Queue<E> {

	private final int MAX_CAPACITY = 1000; 
	private E[] data;
	private int r; /* rear index */ 

	@SuppressWarnings("unchecked")
	public ArrayQueue() {
		data = (E[]) new Object[MAX_CAPACITY]; 
		r = -1; 
	} 

	public int size() { 
		return (r + 1); 
	} 

	public boolean isEmpty() { 
		return (r == -1); 
	} 

	public E first() {
		if (isEmpty()) { /* precondition: non-empty queue */
			throw new IllegalArgumentException("Empty Stack");
		}
		else { 
			return data[0]; 
		} 
	}  

	public void enqueue(E e) {
		if (size() == MAX_CAPACITY) { /* precondition: non-full queue */
			throw new IllegalArgumentException("Full Stack");
		}
		else { 
			r ++; 
			data[r] = e; 
		} 
	} 

	public E dequeue() {
		if (isEmpty()) { /* precondition: non-empty queue */
			throw new IllegalArgumentException("Empty Stack");
		}
		else { 
			E result = data[0];
			for (int i = 0; i < r; i ++) { 
				data[i] = data[i + 1]; 
			}
			data[r] = null;
			r --;
			return result;
		}
	}
}