package tests;
import static org.junit.Assert.*;

import org.junit.Test;

import model.ArrayQueue;
import model.LinkedQueue;
import model.Queue;

@SuppressWarnings("unused")
public class TestQueues {
	
	@Test
	public void testArrayQueue() {
		ArrayQueue<String> s = new ArrayQueue<>();
		assertTrue(s.size() == 0 && s.isEmpty());
		
		try {
			String first = s.first();
			fail("Empty queue should have caused an exception.");
		}
		catch(IllegalArgumentException e) { }
		
		s.enqueue("Alan");
		s.enqueue("Mark");
		s.enqueue("Tom");
		assertTrue(s.size() == 3 && !s.isEmpty());
		assertEquals("Alan", s.first());
		
		String oldFirst = s.dequeue();
		assertEquals("Alan", oldFirst);
		String newFirst = s.first();
		assertEquals("Mark", newFirst);
		
		oldFirst = s.dequeue();
		assertEquals("Mark", oldFirst);
		newFirst = s.first();
		assertEquals("Tom", newFirst);
	}

	@Test
	public void testPolymorphicQueues() {
		Queue<String> q = new ArrayQueue<>(); 
		q.enqueue("Alan"); /* dynamic binding */
		q.enqueue("Mark"); /* dynamic binding */
		q.enqueue("Tom"); /* dynamic binding */
		assertTrue(q.size() == 3 && !q.isEmpty()); 
		assertEquals("Alan", q.first()); 

		q = new LinkedQueue<>(); 
		q.enqueue("Alan"); /* dynamic binding */ 
		q.enqueue("Mark"); /* dynamic binding */ 
		q.enqueue("Tom"); /* dynamic binding */ 
		assertTrue(q.size() == 3 && !q.isEmpty()); 
		assertEquals("Alan", q.first()); 
	}

}
